/* ###################################################################
**     Filename    : main.c
**     Project     : example_7
**     Processor   : MC9S08SE8CRL
**     Version     : Driver 01.12
**     Compiler    : CodeWarrior HCS08 C Compiler
**     Date/Time   : 2023-10-30, 15:37, # CodeGen: 0
**     Abstract    :
**         Main module.
**         This module contains user's application code.
**     Settings    :
**     Contents    :
**         No public methods
**
** ###################################################################*/
/*!
** @file main.c
** @version 01.12
** @brief
**         Main module.
**         This module contains user's application code.
*/         
/*!
**  @addtogroup main_module main module documentation
**  @{
*/         
/* MODULE main */


/* Including needed modules to compile this module/procedure */
#include "Cpu.h"
#include "Events.h"
#include "COPFree.h"
#include "PTB.h"
/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"

/* User includes (#include below this line is not maintained by Processor Expert) */
#include "TM1637.h"
void ADC_Init(void){ //ADC channel 0. If you want to change the channel => ADCSC1=0x20+n, n<=9
	
	ADCCFG=0x75;
	ADCSC2_ADTRG=0;
    ADCSC2_ACFE=0;
	ADCSC2_ACFGT=0;
	ADCSC1=0x20;
}

unsigned int ADC_Read(void)
{   
    while(ADCSC1_COCO==0);
    return (ADCR>>2); //ADC resolution =10 bits
}
void main(void)
{
  /* Write your local variable definition here */
   uint32_t temp=0;
  /*** Processor Expert internal initialization. DON'T REMOVE THIS CODE!!! ***/
  PE_low_level_init();
  /*** End of Processor Expert internal initialization.***/
 
  /* Write your code here */
  COPFree_Init(); 
  PTB_Init();
  ADC_Init();
  TM1637_Init();
  TM1637_DisplayDecimal(0,0,ENABLE_ZEROS);
  Cpu_Delay100US(10000);
  /* For example: for(;;) { } */
  for(;;) {
	  temp=488*ADC_Read();
	  temp=temp/1023;
	  TM1637_DisplayDecimal(temp,0,DISABLE_ZEROS);
	  Cpu_Delay100US(6000);
  }

  /*** Don't write any code pass this line, or it will be deleted during code generation. ***/
  /*** RTOS startup code. Macro PEX_RTOS_START is defined by the RTOS component. DON'T MODIFY THIS CODE!!! ***/
  #ifdef PEX_RTOS_START
    PEX_RTOS_START();                  /* Startup of the selected RTOS. Macro is defined by the RTOS component. */
  #endif
  /*** End of RTOS startup code.  ***/
  /*** Processor Expert end of main routine. DON'T MODIFY THIS CODE!!! ***/
  for(;;){}
  /*** Processor Expert end of main routine. DON'T WRITE CODE BELOW!!! ***/
} /*** End of main routine. DO NOT MODIFY THIS TEXT!!! ***/

/* END main */
/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.3 [05.09]
**     for the Freescale HCS08 series of microcontrollers.
**
** ###################################################################
*/
